Package com.fasterxml.jackson.core.util

# Class DefaultPrettyPrinter

java.lang.Object
com.fasterxml.jackson.core.util.DefaultPrettyPrinter

All Implemented Interfaces:
  `PrettyPrinter`, `Instantiatable<DefaultPrettyPrinter>`, `Serializable`

public class DefaultPrettyPrinter extends Object implements PrettyPrinter, Instantiatable<DefaultPrettyPrinter>, Serializable
Default `PrettyPrinter` implementation that uses 2-space indentation with platform-default linefeeds. Usually this class is not instantiated directly, but instead method `JsonGenerator.useDefaultPrettyPrinter()` is used, which will use an instance of this class for operation.

If you override this class, take note of `Instantiatable`, as subclasses will still create an instance of DefaultPrettyPrinter.

This class is designed for the JSON data format. It works on other formats with same logical model (such as binary `CBOR` and `Smile` formats), but may not work as-is for other data formats, most notably `XML`. It may be necessary to use format-specific `PrettyPrinter` implementation specific to that format.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`DefaultPrettyPrinter.FixedSpaceIndenter`
This is a very simple indenter that only adds a single space for indentation.
`static interface`
`DefaultPrettyPrinter.Indenter`
Interface that defines objects that can produce indentation used to separate object entries and array values.
`static class`
`DefaultPrettyPrinter.NopIndenter`
Dummy implementation that adds no indentation whatsoever

## Field Summary

Fields
Modifier and Type
Field
Description
`protected DefaultPrettyPrinter.Indenter`
`_arrayIndenter`
By default, let's use only spaces to separate array values.
`protected String`
`_arrayValueSeparator`
`protected int`
`_nesting`
Number of open levels of nesting.
`protected String`
`_objectEntrySeparator`
`protected String`
`_objectFieldValueSeparatorWithSpaces`
`protected DefaultPrettyPrinter.Indenter`
`_objectIndenter`
By default, let's use linefeed-adding indenter for separate object entries.
`protected SerializableString`
`_rootSeparator`
String printed between root-level values, if any.
`protected Separators`
`_separators`
`protected boolean`
`_spacesInObjectEntries`
Deprecated.
in 2.16.
`static final SerializedString`
`DEFAULT_ROOT_VALUE_SEPARATOR`
Deprecated.
in 2.16.

### Fields inherited from interface com.fasterxml.jackson.core.PrettyPrinter

`DEFAULT_SEPARATORS`

## Constructor Summary

Constructors
Constructor
Description
`DefaultPrettyPrinter()`
`DefaultPrettyPrinter(SerializableString rootSeparator)`
Deprecated.
in 2.16.
`DefaultPrettyPrinter(DefaultPrettyPrinter base)`
Copy constructor
`DefaultPrettyPrinter(DefaultPrettyPrinter base, SerializableString rootSeparator)`
Deprecated.
in 2.16.
`DefaultPrettyPrinter(Separators separators)`
`DefaultPrettyPrinter(String rootSeparator)`
Deprecated.
in 2.16.

## Method Summary

Modifier and Type
Method
Description
`protected DefaultPrettyPrinter`
`_withSpaces(boolean state)`
`void`
`beforeArrayValues(JsonGenerator g)`
Method called after array start marker has been output, and right before the first value is to be output.
`void`
`beforeObjectEntries(JsonGenerator g)`
Method called after object start marker has been output, and right before the field name of the first entry is to be output.
`DefaultPrettyPrinter`
`createInstance()`
Method called to ensure that we have a non-blueprint object to use; it is either this object (if stateless), or a newly created object with separate state.
`void`
`indentArraysWith(DefaultPrettyPrinter.Indenter i)`
`void`
`indentObjectsWith(DefaultPrettyPrinter.Indenter i)`
`DefaultPrettyPrinter`
`withArrayIndenter(DefaultPrettyPrinter.Indenter i)`
`DefaultPrettyPrinter`
`withObjectIndenter(DefaultPrettyPrinter.Indenter i)`
`DefaultPrettyPrinter`
`withoutSpacesInObjectEntries()`
Deprecated.
in 2.16.
`DefaultPrettyPrinter`
`withRootSeparator(SerializableString rootSeparator)`
Deprecated.
in 2.16.
`DefaultPrettyPrinter`
`withRootSeparator(String rootSeparator)`
Deprecated.
in 2.16.
`DefaultPrettyPrinter`
`withSeparators(Separators separators)`
Method for configuring separators for this pretty-printer to use
`DefaultPrettyPrinter`
`withSpacesInObjectEntries()`
Deprecated.
in 2.16.
`void`
`writeArrayValueSeparator(JsonGenerator g)`
Method called after an array value has been completely output, and before another value is to be output.
`void`
`writeEndArray(JsonGenerator g, int nrOfValues)`
Method called after an Array value has been completely output (minus closing bracket).
`void`
`writeEndObject(JsonGenerator g, int nrOfEntries)`
Method called after an Object value has been completely output (minus closing curly bracket).
`void`
`writeObjectEntrySeparator(JsonGenerator g)`
Method called after an object entry (field:value) has been completely output, and before another value is to be output.
`void`
`writeObjectFieldValueSeparator(JsonGenerator g)`
Method called after an object field has been output, but before the value is output.
`void`
`writeRootValueSeparator(JsonGenerator g)`
Method called after a root-level value has been completely output, and before another value is to be output.
`void`
`writeStartArray(JsonGenerator g)`
Method called when an Array value is to be output, before any member/child values are output.
`void`
`writeStartObject(JsonGenerator g)`
Method called when an Object value is to be output, before any fields are output.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_ROOT_VALUE_SEPARATOR

@Deprecated public static final SerializedString DEFAULT_ROOT_VALUE_SEPARATOR
Deprecated.
in 2.16. Use the Separators API instead.
Constant that specifies default "root-level" separator to use between root values: a single space character.

Since:
  2.1

### _arrayIndenter

protected DefaultPrettyPrinter.Indenter _arrayIndenter
By default, let's use only spaces to separate array values.

### _objectIndenter

protected DefaultPrettyPrinter.Indenter _objectIndenter
By default, let's use linefeed-adding indenter for separate object entries. We'll further configure indenter to use system-specific linefeeds, and 2 spaces per level (as opposed to, say, single tabs)

### _rootSeparator

protected SerializableString _rootSeparator
String printed between root-level values, if any.

### _spacesInObjectEntries

@Deprecated protected boolean _spacesInObjectEntries
Deprecated.
in 2.16. Use Separators API instead.
By default we will add spaces around colons used to separate object fields and values. If disabled, will not use spaces around colon.

### _nesting

protected transient int _nesting
Number of open levels of nesting. Used to determine amount of indentation to use.

### _separators

protected Separators _separators

Since:
  2.9

### _objectFieldValueSeparatorWithSpaces

protected String _objectFieldValueSeparatorWithSpaces

Since:
  2.9

### _objectEntrySeparator

protected String _objectEntrySeparator

Since:
  2.16

### _arrayValueSeparator

protected String _arrayValueSeparator

Since:
  2.16

## Constructor Details

### DefaultPrettyPrinter

public DefaultPrettyPrinter()

### DefaultPrettyPrinter

@Deprecated public DefaultPrettyPrinter(String rootSeparator)
Deprecated.
in 2.16. Use the Separators API instead.
Constructor that specifies separator String to use between root values; if null, no separator is printed.

Note: simply constructs a `SerializedString` out of parameter, calls `DefaultPrettyPrinter(SerializableString)`

Parameters:
  `rootSeparator` - String to use as root value separator

### DefaultPrettyPrinter

@Deprecated public DefaultPrettyPrinter(SerializableString rootSeparator)
Deprecated.
in 2.16. Use the Separators API instead.
Constructor that specifies separator String to use between root values; if null, no separator is printed.

Parameters:
  `rootSeparator` - String to use as root value separator

### DefaultPrettyPrinter

@Deprecated public DefaultPrettyPrinter(DefaultPrettyPrinter base, SerializableString rootSeparator)
Deprecated.
in 2.16. Use the Separators API instead.

### DefaultPrettyPrinter

public DefaultPrettyPrinter(Separators separators)

Since:
  2.16

### DefaultPrettyPrinter

public DefaultPrettyPrinter(DefaultPrettyPrinter base)
Copy constructor

Since:
  2.16

## Method Details

### withRootSeparator

@Deprecated public DefaultPrettyPrinter withRootSeparator(SerializableString rootSeparator)
Deprecated.
in 2.16. Use the Separators API instead.

### withRootSeparator

@Deprecated public DefaultPrettyPrinter withRootSeparator(String rootSeparator)
Deprecated.
in 2.16. Use the Separators API instead.

Parameters:
  `rootSeparator` - Root-level value separator to use
Returns:
  This pretty-printer instance (for call chaining)
Since:
  2.6

### indentArraysWith

public void indentArraysWith(DefaultPrettyPrinter.Indenter i)

### indentObjectsWith

public void indentObjectsWith(DefaultPrettyPrinter.Indenter i)

### withArrayIndenter

public DefaultPrettyPrinter withArrayIndenter(DefaultPrettyPrinter.Indenter i)

Since:
  2.3

### withObjectIndenter

public DefaultPrettyPrinter withObjectIndenter(DefaultPrettyPrinter.Indenter i)

Since:
  2.3

### withSpacesInObjectEntries

@Deprecated public DefaultPrettyPrinter withSpacesInObjectEntries()
Deprecated.
in 2.16. Use the Separators API instead.
"Mutant factory" method that will return a pretty printer instance that does use spaces inside object entries; if 'this' instance already does this, it is returned; if not, a new instance will be constructed and returned.

Returns:
  This pretty-printer instance (for call chaining)
Since:
  2.3

### withoutSpacesInObjectEntries

@Deprecated public DefaultPrettyPrinter withoutSpacesInObjectEntries()
Deprecated.
in 2.16. Use the Separators API instead.
"Mutant factory" method that will return a pretty printer instance that does not use spaces inside object entries; if 'this' instance already does this, it is returned; if not, a new instance will be constructed and returned.

Returns:
  This pretty-printer instance (for call chaining)
Since:
  2.3

### _withSpaces

protected DefaultPrettyPrinter _withSpaces(boolean state)

### withSeparators

public DefaultPrettyPrinter withSeparators(Separators separators)
Method for configuring separators for this pretty-printer to use

Parameters:
  `separators` - Separator definitions to use
Returns:
  This pretty-printer instance (for call chaining)
Since:
  2.9

### createInstance

public DefaultPrettyPrinter createInstance()
Description copied from interface: `Instantiatable`
Method called to ensure that we have a non-blueprint object to use; it is either this object (if stateless), or a newly created object with separate state.

Specified by:
  `createInstance` in interface `Instantiatable<DefaultPrettyPrinter>`
Returns:
  Actual instance to use

### writeRootValueSeparator

public void writeRootValueSeparator(JsonGenerator g) throws IOException
Description copied from interface: `PrettyPrinter`
Method called after a root-level value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a space, to allow values to be parsed correctly. Pretty-printer is to output some other suitable and nice-looking separator (tab(s), space(s), linefeed(s) or any combination thereof).

Specified by:
  `writeRootValueSeparator` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeStartObject

public void writeStartObject(JsonGenerator g) throws IOException
Description copied from interface: `PrettyPrinter`
Method called when an Object value is to be output, before any fields are output.

Default handling (without pretty-printing) will output the opening curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeStartObject` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### beforeObjectEntries

public void beforeObjectEntries(JsonGenerator g) throws IOException
Description copied from interface: `PrettyPrinter`
Method called after object start marker has been output, and right before the field name of the first entry is to be output. It is not called for objects without entries.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Specified by:
  `beforeObjectEntries` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeObjectFieldValueSeparator

public void writeObjectFieldValueSeparator(JsonGenerator g) throws IOException
Method called after an object field has been output, but before the value is output.

Default handling (without pretty-printing) will output a single colon to separate the two. Pretty-printer is to output a colon as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeObjectFieldValueSeparator` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeObjectEntrySeparator

public void writeObjectEntrySeparator(JsonGenerator g) throws IOException
Method called after an object entry (field:value) has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeObjectEntrySeparator` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeEndObject

public void writeEndObject(JsonGenerator g, int nrOfEntries) throws IOException
Description copied from interface: `PrettyPrinter`
Method called after an Object value has been completely output (minus closing curly bracket).

Default handling (without pretty-printing) will output the closing curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeEndObject` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
  `nrOfEntries` - Number of direct members of the Object that have been output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeStartArray

public void writeStartArray(JsonGenerator g) throws IOException
Description copied from interface: `PrettyPrinter`
Method called when an Array value is to be output, before any member/child values are output.

Default handling (without pretty-printing) will output the opening bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeStartArray` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### beforeArrayValues

public void beforeArrayValues(JsonGenerator g) throws IOException
Description copied from interface: `PrettyPrinter`
Method called after array start marker has been output, and right before the first value is to be output. It is not called for arrays with no values.

Default handling does not output anything, but pretty-printer is free to add any white space decoration.

Specified by:
  `beforeArrayValues` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeArrayValueSeparator

public void writeArrayValueSeparator(JsonGenerator g) throws IOException
Method called after an array value has been completely output, and before another value is to be output.

Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeArrayValueSeparator` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer

### writeEndArray

public void writeEndArray(JsonGenerator g, int nrOfValues) throws IOException
Description copied from interface: `PrettyPrinter`
Method called after an Array value has been completely output (minus closing bracket).

Default handling (without pretty-printing) will output the closing bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

Specified by:
  `writeEndArray` in interface `PrettyPrinter`
Parameters:
  `g` - Generator used for output
  `nrOfValues` - Number of direct members of the array that have been output
Throws:
  `IOException` - if there is either an underlying I/O problem or encoding issue at format layer